<?php
/*
 * Joomla JoomShopping
 * Модуль для подключения платежной системы IntellectMoney
 *
Last Changed Rev: 13371
Last Changed Date: 2012-01-23 15:44:29 +0400 (Mon, 23 Jan 2012)
 */
?>
<?php
defined('_JEXEC') or die('Restricted access');

class pm_im extends PaymentRoot{
    
    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
	  $array_params = array('transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  } 
	  $orders = &JModelLegacy::getInstance('orders', 'JshoppingModel'); //admin model
      include(dirname(__FILE__)."/adminparamsform.php");	  
	}

	function checkTransaction($pmconfigs, $order, $act)
	{
		$secretKeyLocal = $pmconfigs['secret_key'];
		$eshopIdLocal = $pmconfigs['eshop_id'];
		$recipientAmountLocal = number_format(floatval($order->order_total), 2, '.', '');
		$recipientCurrencyLocal = $order->currency_code_iso;
		
		// Получаем информацию о платеже
		$eshopId = trim(stripslashes($_REQUEST['eshopId']));					// 1.Номер сайта продавца (eshopId);
		$orderId = trim(stripslashes($_REQUEST['orderId']));					// 2.Номер счета продавца (orderId);
		$serviceName = trim(stripslashes($_REQUEST['serviceName']));			// 3.Описание покупки (serviceName);
		$eshopAccount = trim(stripslashes($_REQUEST['eshopAccount']));			// 4.Номер счета в системе Intellectmoney (eshopAccount);
		$recipientAmount = trim(stripslashes($_REQUEST['recipientAmount']));	// 5.Сумма платежа (recipientAmount);
		$recipientCurrency =trim(stripslashes($_REQUEST['recipientCurrency'])); // 6.Валюта платежа (recipientCurrency);
		$paymentStatus = trim(stripslashes($_REQUEST['paymentStatus']));		// 7.Статус платежа (paymentStatus);
		$userName = trim(stripslashes($_REQUEST['userName']));					// 8.Имя покупателя (userName);
		$userEmail = trim(stripslashes($_REQUEST['userEmail']));				// 9.Email покупателя (userEmail);
		$paymentData = trim(stripslashes($_REQUEST['paymentData']));			// 10.Дата и время выполнения платежа(paymentData);
		$secretKey = trim(stripslashes($_REQUEST['secretKey']));				// 11.Секретный ключ (secretKey);
		$hash = trim(stripslashes($_REQUEST['hash']));							// Контрольная подпись
		
		// проверяем корректность операции
		if(isset($secretKey) && $secretKey) {
			if($secretKey != $secretKeyLocal)
				return array(0, "Ошибка: Секретное слово не верное! SecretKey: ".$secretKey);
			if($eshopId != $eshopIdLocal)
				return array(0, "Ошибка: Номера сайта не соответствует!");
			if($recipientAmount != $recipientAmountLocal || $recipientCurrency != $recipientCurrencyLocal)
				return array(0, "Ошибка: Сумма транзакции не совпадает с суммой заказа!");
		}
		else {
			
			$control_hash = $eshopId."::".$orderId."::".$serviceName."::".$eshopAccount."::".
				$recipientAmount."::".$recipientCurrency."::".$paymentStatus."::".$userName.'::'.
				$userEmail.'::'.$paymentData.'::'.$secretKeyLocal;
			
			$control_hash_urldecode = urldecode($control_hash);
			
			$control_hash_urldecode_utf8 = mb_convert_encoding($control_hash_urldecode,'windows-1251', 'utf-8');
			
			$control_hash_urldecode_win =  mb_convert_encoding($control_hash_urldecode,'utf-8', 'windows-1251');
			
			switch ($hash){
				case md5($control_hash):
					break;
				case md5($control_hash_urldecode):
					break;
				case md5($control_hash_urldecode_utf8):
					break;
				case md5($control_hash_urldecode_win):
					break;
				default: 
					return array(0, "Ошибка: Хеш не соответствует.");
			}
		}
		
		echo "OK";
		// created
		if($_REQUEST['paymentStatus'] == 3)
			return array(2, "Status pending. Order ID ".$order->order_id);
		// paid
		if($_REQUEST['paymentStatus'] == 5)
			return array(1, "Status paid. Order ID ".$order->order_id);
	}

	function showEndForm($pmconfigs, $order)
	{
        $notify_url = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=pm_im&no_lang=1";
        $return = JURI::root(). "index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=pm_im";
        $cancel_return = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=pm_im";

		$host = 'https://merchant.intellectmoney.ru/ru/';
        $item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
        
        ?>
        <html>
        <body>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="<?php print $host?>" name="paymentform" method="post">
			<input type="hidden" name="eshopId" value="<?php echo $pmconfigs['eshop_id'] ?>">
			<input type="hidden" name="orderId" value="<?php echo $order->order_id ?>">
			<input type="hidden" name="serviceName" value="<?php echo $item_name ?>">
			<input type="hidden" name="recipientAmount" value="<?php echo (number_format(floatval($order->order_total), 2, '.', '')) ?>">
			<input type="hidden" name="recipientCurrency" value="<?php echo $order->currency_code_iso ?>">
			<input type="hidden" name="successUrl" value="<?php echo $return ?>">
			<input type="hidden" name="failUrl" value="<?php echo $cancel_return ?>">
        </form>        
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
    
    function getUrlParams($pmconfigs)
    {
        $params = array(); 
        $params['order_id'] = JRequest::getInt("orderId");
        $params['hash'] = JRequest::getString("hash");
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = 0;
		return $params;
    }
    
}

?>